﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Diagnostics;

namespace TestingGarbageCollectorBehavior {

	class A {
		public int a;
		public int b;
		public int c;
		public int d;
		public int e;
		public A next;
	}

	class Program {
		static void Main(string[] args) {
			Console.WriteLine($"Environment.Is64BitProcess? {Environment.Is64BitProcess}");

			List<A> list = new List<A>(100_000 /* force on LOH */);

			A longLiving = null;
			A firstLongLiving = null;

			var sw = new Stopwatch();

			var lastGen0 = GC.CollectionCount(0);
			var lastGen1 = GC.CollectionCount(1);
			var lastGen2 = GC.CollectionCount(2);
			for (int i = 0; i < 35_000_000; i++) {
				sw.Restart();	
				var a = new A();
				sw.Stop();

				if (i > 940_000 && i % 1_000 == 0 && i < 20_000_000) { a.next = longLiving; longLiving = a; firstLongLiving = firstLongLiving == null ? longLiving : firstLongLiving; list.Add(a); }
				if (i > 5_000_000 && i % 2 == 0 && i < 20_000_000) { a.next = longLiving; longLiving = a; firstLongLiving = firstLongLiving == null ? longLiving : firstLongLiving; }
				if (i == 5_000_000) { Console.WriteLine(); Console.WriteLine("************"); Console.WriteLine(); }
				if (i == 20_000_000) { Console.WriteLine(); Console.WriteLine("============="); Console.WriteLine(); longLiving = null; firstLongLiving = null; list.Clear(); }
				if (i == 30_000_000) { GC.Collect(); Console.WriteLine(); Console.WriteLine("... Forcing full GC collect ..."); Console.WriteLine(); }

				bool print = i % 10_000 == 0;
				if (print) {
					Console.Write($"Object {i,8}: {sw.ElapsedTicks,5} ticks, total memory on heap: {GC.GetTotalMemory(false) / 1024,5} kB");
					if (firstLongLiving == null) Console.WriteLine(); else Console.WriteLine($" | long[0] in Gen{GC.GetGeneration(firstLongLiving)}");
				}

				var gen0 = GC.CollectionCount(0);
				var gen1 = GC.CollectionCount(1);
				var gen2 = GC.CollectionCount(2);

				if (gen0 != lastGen0 || gen1 != lastGen1 || gen2 != lastGen2) {
					if (!print) {
						Console.Write($"Object {i,8}: {sw.ElapsedTicks,5} ticks, total memory on heap: {GC.GetTotalMemory(false) / 1024,5} kB");
						if (firstLongLiving == null) Console.WriteLine(); else Console.WriteLine($" | long[0] in Gen{GC.GetGeneration(firstLongLiving)}");
					}
					Console.WriteLine($"  => Gen0: {lastGen0,3} -> {gen0,3} | Gen1: {lastGen1,3} -> {gen1,3} | Gen2: {lastGen2,3} -> {gen2,3}");
					lastGen0 = gen0;
					lastGen1 = gen1;
					lastGen2 = gen2;
				}
			}
		}
	}
}
